diff --git a/CHANGELOG.MD b/CHANGELOG.MD
index bc5802e1..ef1ea9a0 100644
--- a/CHANGELOG.MD
+++ b/CHANGELOG.MD
@@ -29,6 +29,12 @@ All notable changes to this project will be documented in this file.
- New V3 Install Script
- **Wireguard LXC**
- New V3 Install Script
+- **Node-Red LXC**
+ - New V3 Install Script
+- **MQTT LXC**
+ - New V3 Install Script
+- **Mariadb LXC**
+ - New V3 Install Script
## 2022-04-17
diff --git a/README.md b/README.md
index 21f43a96..51831d26 100644
--- a/README.md
+++ b/README.md
@@ -407,17 +407,17 @@ bash -c "$(wget -qLO - https://github.com/tteck/Proxmox/raw/main/misc/npm_update
- MQTT LXC
+ 🔸MQTT LXC
MQTT LXC
-To create a new Proxmox MQTT LXC, run the following in the Proxmox Shell (V2).
+To create a new Proxmox MQTT LXC, run the following in the Proxmox Shell.
```yaml
-bash -c "$(wget -qLO - https://github.com/tteck/Proxmox/raw/main/ct/mqtt.sh)"
+bash -c "$(wget -qLO - https://github.com/tteck/Proxmox/raw/main/ct/mqtt-v3.sh)"
```
âš¡ Default Settings: 512MiB RAM - 2GB Storage - 1vCPU âš¡
@@ -458,17 +458,17 @@ ________________________________________________________________________________
- Node-Red LXC
+ 🔸Node-Red LXC
Node-Red LXC
-To create a new Proxmox Node-RED LXC, run the following in the Proxmox Shell (V2).
+To create a new Proxmox Node-RED LXC, run the following in the Proxmox Shell.
```yaml
-bash -c "$(wget -qLO - https://github.com/tteck/Proxmox/raw/main/ct/node-red.sh)"
+bash -c "$(wget -qLO - https://github.com/tteck/Proxmox/raw/main/ct/node-red-v3.sh)"
```
âš¡ Default Settings: 1GB RAM - 4GB Storage - 1vCPU âš¡
@@ -501,16 +501,16 @@ ________________________________________________________________________________
- Mariadb LXC
+ 🔸Mariadb LXC
Mariadb LXC
-To create a new Proxmox Mariadb LXC, run the following in the Proxmox Shell (V2).
+To create a new Proxmox Mariadb LXC, run the following in the Proxmox Shell.
```yaml
-bash -c "$(wget -qLO - https://github.com/tteck/Proxmox/raw/main/ct/mariadb.sh)"
+bash -c "$(wget -qLO - https://github.com/tteck/Proxmox/raw/main/ct/mariadb-v3.sh)"
```
âš¡ Default Settings: 1GB RAM - 4GB Storage - 1vCPU âš¡
diff --git a/ct/mariadb_container.sh b/ct/mariadb-v1.sh
similarity index 100%
rename from ct/mariadb_container.sh
rename to ct/mariadb-v1.sh
diff --git a/ct/mariadb.sh b/ct/mariadb-v2.sh
similarity index 100%
rename from ct/mariadb.sh
rename to ct/mariadb-v2.sh
diff --git a/ct/mariadb-v3.sh b/ct/mariadb-v3.sh
new file mode 100644
index 00000000..15c26710
--- /dev/null
+++ b/ct/mariadb-v3.sh
@@ -0,0 +1,315 @@
+#!/usr/bin/env bash -ex
+set -euo pipefail
+shopt -s inherit_errexit nullglob
+
+NEXTID=$(pvesh get /cluster/nextid)
+INTEGER='^[0-9]+$'
+YW=`echo "\033[33m"`
+BL=`echo "\033[36m"`
+RD=`echo "\033[01;31m"`
+BGN=`echo "\033[4;92m"`
+GN=`echo "\033[1;92m"`
+DGN=`echo "\033[32m"`
+CL=`echo "\033[m"`
+BFR="\\r\\033[K"
+HOLD="-"
+CM="${GN}✓${CL}"
+APP="MariaDB"
+NSAPP=$(echo ${APP,,} | tr -d ' ')
+while true; do
+ read -p "This will create a New ${APP} LXC. Proceed(y/n)?" yn
+ case $yn in
+ [Yy]* ) break;;
+ [Nn]* ) exit;;
+ * ) echo "Please answer yes or no.";;
+ esac
+done
+clear
+function header_info {
+echo -e "${BL}
+ __ __ _ _ _
+ | \/ | (_) | | |
+ | \ / | __ _ _ __ _ __ _ __| | |__
+ | |\/| |/ _ | __| |/ _ |/ _ | _ \
+ | | | | (_| | | | | (_| | (_| | |_) |
+ |_| |_|\__,_|_|v3|_|\__,_|\__,_|_.__/
+${CL}"
+}
+
+header_info
+
+function msg_info() {
+ local msg="$1"
+ echo -ne " ${HOLD} ${YW}${msg}..."
+}
+
+function msg_ok() {
+ local msg="$1"
+ echo -e "${BFR} ${CM} ${GN}${msg}${CL}"
+}
+
+function PVE_CHECK() {
+ PVE=$(pveversion | grep "pve-manager/7" | wc -l)
+
+ if [[ $PVE != 1 ]]; then
+ echo -e "${RD}This script requires Proxmox Virtual Environment 7.0 or greater${CL}"
+ echo -e "Exiting..."
+ sleep 2
+ exit
+ fi
+}
+
+function default_settings() {
+ clear
+ header_info
+ echo -e "${BL}Using Default Settings${CL}"
+ echo -e "${DGN}Using CT Type ${BGN}Unprivileged${CL} ${RD}NO DEVICE PASSTHROUGH${CL}"
+ CT_TYPE="1"
+ echo -e "${DGN}Using CT Password ${BGN}Automatic Login${CL}"
+ PW=" "
+ echo -e "${DGN}Using CT ID ${BGN}$NEXTID${CL}"
+ CT_ID=$NEXTID
+ echo -e "${DGN}Using CT Name ${BGN}$NSAPP${CL}"
+ HN=$NSAPP
+ echo -e "${DGN}Using Disk Size ${BGN}4GB${CL}"
+ DISK_SIZE="4"
+ echo -e "${DGN}Using ${BGN}1vCPU${CL}"
+ CORE_COUNT="1"
+ echo -e "${DGN}Using ${BGN}1024MiB${CL}${DGN} RAM${CL}"
+ RAM_SIZE="1024"
+ echo -e "${DGN}Using Static IP Address ${BGN}DHCP${CL}"
+ NET=dhcp
+ echo -e "${DGN}Using Gateway Address ${BGN}NONE${CL}"
+ GATE=" "
+ echo -e "${DGN}Using VLAN Tag ${BGN}NONE${CL}"
+ VLAN=" "
+}
+
+function advanced_settings() {
+ clear
+ header_info
+ echo -e "${RD}Using Advanced Settings${CL}"
+ echo -e "${YW}Type Privileged, or Press [ENTER] for Default: Unprivileged (${RD}NO DEVICE PASSTHROUGH${CL}${YW})"
+ read CT_TYPE1
+ if [ -z $CT_TYPE1 ]; then CT_TYPE1="Unprivileged" CT_TYPE="1";
+ echo -en "${DGN}Set CT Type ${BL}$CT_TYPE1${CL}"
+ else
+ CT_TYPE1="Privileged"
+ CT_TYPE="0"
+ echo -en "${DGN}Set CT Type ${BL}Privileged${CL}"
+ fi;
+echo -e " ${CM}${CL} \r"
+sleep 1
+clear
+header_info
+ echo -e "${RD}Using Advanced Settings${CL}"
+ echo -e "${DGN}Using CT Type ${BGN}$CT_TYPE1${CL}"
+ echo -e "${YW}Set Password, or Press [ENTER] for Default: Automatic Login "
+ read PW1
+ if [ -z $PW1 ]; then PW1="Automatic Login" PW=" ";
+ echo -en "${DGN}Set CT ${BL}$PW1${CL}"
+ else
+ PW="-password $PW1"
+ echo -en "${DGN}Set CT Password ${BL}$PW1${CL}"
+ fi;
+echo -e " ${CM}${CL} \r"
+sleep 1
+clear
+header_info
+ echo -e "${RD}Using Advanced Settings${CL}"
+ echo -e "${DGN}Using CT Type ${BGN}$CT_TYPE1${CL}"
+ echo -e "${DGN}Using CT Password ${BGN}$PW1${CL}"
+ echo -e "${YW}Enter the CT ID, or Press [ENTER] to automatically generate (${NEXTID}) "
+ read CT_ID
+ if [ -z $CT_ID ]; then CT_ID=$NEXTID; fi;
+ echo -en "${DGN}Set CT ID To ${BL}$CT_ID${CL}"
+echo -e " ${CM}${CL} \r"
+sleep 1
+clear
+header_info
+ echo -e "${RD}Using Advanced Settings${CL}"
+ echo -e "${DGN}Using CT Type ${BGN}$CT_TYPE1${CL}"
+ echo -e "${DGN}Using CT Password ${BGN}$PW1${CL}"
+ echo -e "${DGN}Using CT ID ${BGN}$CT_ID${CL}"
+ echo -e "${YW}Enter CT Name (no-spaces), or Press [ENTER] for Default: $NSAPP "
+ read CT_NAME
+ if [ -z $CT_NAME ]; then
+ HN=$NSAPP
+ else
+ HN=$(echo ${CT_NAME,,} | tr -d ' ')
+ fi
+ echo -en "${DGN}Set CT Name To ${BL}$HN${CL}"
+echo -e " ${CM}${CL} \r"
+sleep 1
+clear
+header_info
+ echo -e "${RD}Using Advanced Settings${CL}"
+ echo -e "${DGN}Using CT Type ${BGN}$CT_TYPE1${CL}"
+ echo -e "${DGN}Using CT Password ${BGN}$PW1${CL}"
+ echo -e "${DGN}Using CT ID ${BGN}$CT_ID${CL}"
+ echo -e "${DGN}Using CT Name ${BGN}$HN${CL}"
+ echo -e "${YW}Enter a Disk Size, or Press [ENTER] for Default: 4Gb "
+ read DISK_SIZE
+ if [ -z $DISK_SIZE ]; then DISK_SIZE="4"; fi;
+ if ! [[ $DISK_SIZE =~ $INTEGER ]] ; then echo "ERROR! DISK SIZE MUST HAVE INTEGER NUMBER!"; exit; fi;
+ echo -en "${DGN}Set Disk Size To ${BL}$DISK_SIZE${CL}"
+echo -e " ${CM}${CL} \r"
+sleep 1
+clear
+header_info
+ echo -e "${RD}Using Advanced Settings${CL}"
+ echo -e "${DGN}Using CT Type ${BGN}$CT_TYPE1${CL}"
+ echo -e "${DGN}Using CT Password ${BGN}$PW1${CL}"
+ echo -e "${DGN}Using CT ID ${BGN}$CT_ID${CL}"
+ echo -e "${DGN}Using CT Name ${BGN}$HN${CL}"
+ echo -e "${DGN}Using Disk Size ${BGN}$DISK_SIZE${CL}"
+ echo -e "${YW}Allocate CPU cores, or Press [ENTER] for Default: 1 "
+ read CORE_COUNT
+ if [ -z $CORE_COUNT ]; then CORE_COUNT="1"; fi;
+ echo -en "${DGN}Set Cores To ${BL}$CORE_COUNT${CL}"
+echo -e " ${CM}${CL} \r"
+sleep 1
+clear
+header_info
+ echo -e "${RD}Using Advanced Settings${CL}"
+ echo -e "${DGN}Using CT Type ${BGN}$CT_TYPE1${CL}"
+ echo -e "${DGN}Using CT Password ${BGN}$PW1${CL}"
+ echo -e "${DGN}Using CT ID ${BGN}$CT_ID${CL}"
+ echo -e "${DGN}Using CT Name ${BGN}$HN${CL}"
+ echo -e "${DGN}Using Disk Size ${BGN}$DISK_SIZE${CL}"
+ echo -e "${DGN}Using ${BGN}${CORE_COUNT}vCPU${CL}"
+ echo -e "${YW}Allocate RAM in MiB, or Press [ENTER] for Default: 1024 "
+ read RAM_SIZE
+ if [ -z $RAM_SIZE ]; then RAM_SIZE="1024"; fi;
+ echo -en "${DGN}Set RAM To ${BL}$RAM_SIZE${CL}"
+echo -e " ${CM}${CL} \n"
+sleep 1
+clear
+header_info
+ echo -e "${RD}Using Advanced Settings${CL}"
+ echo -e "${DGN}Using CT Type ${BGN}$CT_TYPE1${CL}"
+ echo -e "${DGN}Using CT Password ${BGN}$PW1${CL}"
+ echo -e "${DGN}Using CT ID ${BGN}$CT_ID${CL}"
+ echo -e "${DGN}Using CT Name ${BGN}$HN${CL}"
+ echo -e "${DGN}Using Disk Size ${BGN}$DISK_SIZE${CL}"
+ echo -e "${DGN}Using ${BGN}${CORE_COUNT}vCPU${CL}"
+ echo -e "${DGN}Using ${BGN}${RAM_SIZE}MiB${CL}${DGN} RAM${CL}"
+ echo -e "${YW}Enter a Static IP Address, or Press [ENTER] for Default: DHCP "
+ read NET
+ if [ -z $NET ]; then NET="dhcp"; fi;
+ echo -en "${DGN}Set Static IP Address To ${BL}$NET${CL}"
+echo -e " ${CM}${CL} \n"
+sleep 1
+clear
+header_info
+ echo -e "${RD}Using Advanced Settings${CL}"
+ echo -e "${DGN}Using CT Type ${BGN}$CT_TYPE1${CL}"
+ echo -e "${DGN}Using CT Password ${BGN}$PW1${CL}"
+ echo -e "${DGN}Using CT ID ${BGN}$CT_ID${CL}"
+ echo -e "${DGN}Using CT Name ${BGN}$HN${CL}"
+ echo -e "${DGN}Using Disk Size ${BGN}$DISK_SIZE${CL}"
+ echo -e "${DGN}Using ${BGN}${CORE_COUNT}vCPU${CL}"
+ echo -e "${DGN}Using ${BGN}${RAM_SIZE}MiB${CL}${DGN} RAM${CL}"
+ echo -e "${DGN}Using Static IP Address ${BGN}$NET${CL}"
+ echo -e "${YW}Enter a Gateway IP, or Press [ENTER] for Default: NONE "
+ read GATE1
+ if [ -z $GATE1 ]; then GATE1="NONE" GATE=" ";
+ echo -en "${DGN}Set Gateway IP To ${BL}$GATE1${CL}"
+ else
+ GATE=",gw=$GATE1"
+ echo -en "${DGN}Set Gateway IP To ${BL}$GATE1${CL}"
+ fi;
+echo -e " ${CM}${CL} \n"
+sleep 1
+clear
+header_info
+
+ echo -e "${RD}Using Advanced Settings${CL}"
+ echo -e "${DGN}Using CT Type ${BGN}$CT_TYPE1${CL}"
+ echo -e "${DGN}Using CT Password ${BGN}$PW1${CL}"
+ echo -e "${DGN}Using CT ID ${BGN}$CT_ID${CL}"
+ echo -e "${DGN}Using CT Name ${BGN}$HN${CL}"
+ echo -e "${DGN}Using Disk Size ${BGN}$DISK_SIZE${CL}"
+ echo -e "${DGN}Using ${BGN}${CORE_COUNT}vCPU${CL}"
+ echo -e "${DGN}Using ${BGN}${RAM_SIZE}MiB${CL}${DGN} RAM${CL}"
+ echo -e "${DGN}Using Static IP Address ${BGN}$NET${CL}"
+ echo -e "${DGN}Using Gateway IP Address ${BGN}$GATE1${CL}"
+ echo -e "${YW}Enter a VLAN Tag, or Press [ENTER] for Default: NONE "
+ read VLAN1
+ if [ -z $VLAN1 ]; then VLAN1="NONE" VLAN=" ";
+ echo -en "${DGN}Set VLAN Tag To ${BL}$VLAN1${CL}"
+ else
+ VLAN=",tag=$VLAN1"
+ echo -en "${DGN}Set VLAN Tag To ${BL}$VLAN1${CL}"
+ fi;
+echo -e " ${CM}${CL} \n"
+sleep 1
+clear
+header_info
+ echo -e "${RD}Using Advanced Settings${CL}"
+ echo -e "${DGN}Using CT Type ${BGN}$CT_TYPE1${CL}"
+ echo -e "${DGN}Using CT Password ${BGN}$PW1${CL}"
+ echo -e "${DGN}Using CT ID ${BGN}$CT_ID${CL}"
+ echo -e "${DGN}Using CT Name ${BGN}$HN${CL}"
+ echo -e "${DGN}Using Disk Size ${BGN}$DISK_SIZE${CL}"
+ echo -e "${DGN}Using ${BGN}${CORE_COUNT}vCPU${CL}"
+ echo -e "${DGN}Using ${BGN}${RAM_SIZE}MiB${CL}${DGN} RAM${CL}"
+ echo -e "${DGN}Using Static IP Address ${BGN}$NET${CL}"
+ echo -e "${DGN}Using Gateway IP Address ${BGN}$GATE1${CL}"
+ echo -e "${DGN}Using VLAN Tag ${BGN}$VLAN1${CL}"
+
+read -p "Are these settings correct(y/n)? " -n 1 -r
+echo
+if [[ ! $REPLY =~ ^[Yy]$ ]]
+then
+ advanced_settings
+fi
+}
+
+function start_script() {
+ echo -e "${YW}Type Advanced, or Press [ENTER] for Default Settings "
+ read SETTINGS
+ if [ -z $SETTINGS ]; then default_settings;
+ else
+ advanced_settings
+ fi;
+}
+
+start_script
+
+if [ "$CT_TYPE" == "1" ]; then
+ FEATURES="nesting=1,keyctl=1"
+ else
+ FEATURES="nesting=1"
+ fi
+
+TEMP_DIR=$(mktemp -d)
+pushd $TEMP_DIR >/dev/null
+
+export CTID=$CT_ID
+export PCT_OSTYPE=debian
+export PCT_OSVERSION=11
+export PCT_DISK_SIZE=$DISK_SIZE
+export PCT_OPTIONS="
+ -features $FEATURES
+ -hostname $HN
+ -net0 name=eth0,bridge=vmbr0,ip=$NET$GATE$VLAN
+ -onboot 1
+ -cores $CORE_COUNT
+ -memory $RAM_SIZE
+ -unprivileged $CT_TYPE
+ $PW
+"
+bash -c "$(wget -qLO - https://raw.githubusercontent.com/tteck/Proxmox/main/ct/create_lxc.sh)" || exit
+
+msg_info "Starting LXC Container"
+pct start $CTID
+msg_ok "Started LXC Container"
+
+lxc-attach -n $CTID -- bash -c "$(wget -qLO - https://raw.githubusercontent.com/tteck/Proxmox/main/setup/mariadb-install.sh)" || exit
+
+IP=$(pct exec $CTID ip a s dev eth0 | sed -n '/inet / s/\// /p' | awk '{print $2}')
+
+msg_ok "Completed Successfully!\n"
+echo -e "Adminer should be reachable by going to the following URL.
+ ${BL}http://${IP}/adminer/${CL} \n"
diff --git a/ct/mqtt_container.sh b/ct/mqtt-v1.sh
similarity index 100%
rename from ct/mqtt_container.sh
rename to ct/mqtt-v1.sh
diff --git a/ct/mqtt.sh b/ct/mqtt-v2.sh
similarity index 100%
rename from ct/mqtt.sh
rename to ct/mqtt-v2.sh
diff --git a/ct/mqtt-v3.sh b/ct/mqtt-v3.sh
new file mode 100644
index 00000000..d2e43ca5
--- /dev/null
+++ b/ct/mqtt-v3.sh
@@ -0,0 +1,313 @@
+#!/usr/bin/env bash -ex
+set -euo pipefail
+shopt -s inherit_errexit nullglob
+
+NEXTID=$(pvesh get /cluster/nextid)
+INTEGER='^[0-9]+$'
+YW=`echo "\033[33m"`
+BL=`echo "\033[36m"`
+RD=`echo "\033[01;31m"`
+BGN=`echo "\033[4;92m"`
+GN=`echo "\033[1;92m"`
+DGN=`echo "\033[32m"`
+CL=`echo "\033[m"`
+BFR="\\r\\033[K"
+HOLD="-"
+CM="${GN}✓${CL}"
+APP="MQTT"
+NSAPP=$(echo ${APP,,} | tr -d ' ')
+while true; do
+ read -p "This will create a New ${APP} LXC. Proceed(y/n)?" yn
+ case $yn in
+ [Yy]* ) break;;
+ [Nn]* ) exit;;
+ * ) echo "Please answer yes or no.";;
+ esac
+done
+clear
+function header_info {
+echo -e "${BL}
+ __ __ ____ _______ _______
+ | \/ |/ __ \__ __|__ __|
+ | \ / | | | | | | | |
+ | |\/| | | | | | | | |
+ | | | | |__| | | | | |
+ |_| |_|\___\_\ |_| v3 |_|
+${CL}"
+}
+
+header_info
+
+function msg_info() {
+ local msg="$1"
+ echo -ne " ${HOLD} ${YW}${msg}..."
+}
+
+function msg_ok() {
+ local msg="$1"
+ echo -e "${BFR} ${CM} ${GN}${msg}${CL}"
+}
+
+function PVE_CHECK() {
+ PVE=$(pveversion | grep "pve-manager/7" | wc -l)
+
+ if [[ $PVE != 1 ]]; then
+ echo -e "${RD}This script requires Proxmox Virtual Environment 7.0 or greater${CL}"
+ echo -e "Exiting..."
+ sleep 2
+ exit
+ fi
+}
+
+function default_settings() {
+ clear
+ header_info
+ echo -e "${BL}Using Default Settings${CL}"
+ echo -e "${DGN}Using CT Type ${BGN}Unprivileged${CL} ${RD}NO DEVICE PASSTHROUGH${CL}"
+ CT_TYPE="1"
+ echo -e "${DGN}Using CT Password ${BGN}Automatic Login${CL}"
+ PW=" "
+ echo -e "${DGN}Using CT ID ${BGN}$NEXTID${CL}"
+ CT_ID=$NEXTID
+ echo -e "${DGN}Using CT Name ${BGN}$NSAPP${CL}"
+ HN=$NSAPP
+ echo -e "${DGN}Using Disk Size ${BGN}2GB${CL}"
+ DISK_SIZE="2"
+ echo -e "${DGN}Using ${BGN}1vCPU${CL}"
+ CORE_COUNT="1"
+ echo -e "${DGN}Using ${BGN}512MiB${CL}${DGN} RAM${CL}"
+ RAM_SIZE="512"
+ echo -e "${DGN}Using Static IP Address ${BGN}DHCP${CL}"
+ NET=dhcp
+ echo -e "${DGN}Using Gateway Address ${BGN}NONE${CL}"
+ GATE=" "
+ echo -e "${DGN}Using VLAN Tag ${BGN}NONE${CL}"
+ VLAN=" "
+}
+
+function advanced_settings() {
+ clear
+ header_info
+ echo -e "${RD}Using Advanced Settings${CL}"
+ echo -e "${YW}Type Privileged, or Press [ENTER] for Default: Unprivileged (${RD}NO DEVICE PASSTHROUGH${CL}${YW})"
+ read CT_TYPE1
+ if [ -z $CT_TYPE1 ]; then CT_TYPE1="Unprivileged" CT_TYPE="1";
+ echo -en "${DGN}Set CT Type ${BL}$CT_TYPE1${CL}"
+ else
+ CT_TYPE1="Privileged"
+ CT_TYPE="0"
+ echo -en "${DGN}Set CT Type ${BL}Privileged${CL}"
+ fi;
+echo -e " ${CM}${CL} \r"
+sleep 1
+clear
+header_info
+ echo -e "${RD}Using Advanced Settings${CL}"
+ echo -e "${DGN}Using CT Type ${BGN}$CT_TYPE1${CL}"
+ echo -e "${YW}Set Password, or Press [ENTER] for Default: Automatic Login "
+ read PW1
+ if [ -z $PW1 ]; then PW1="Automatic Login" PW=" ";
+ echo -en "${DGN}Set CT ${BL}$PW1${CL}"
+ else
+ PW="-password $PW1"
+ echo -en "${DGN}Set CT Password ${BL}$PW1${CL}"
+ fi;
+echo -e " ${CM}${CL} \r"
+sleep 1
+clear
+header_info
+ echo -e "${RD}Using Advanced Settings${CL}"
+ echo -e "${DGN}Using CT Type ${BGN}$CT_TYPE1${CL}"
+ echo -e "${DGN}Using CT Password ${BGN}$PW1${CL}"
+ echo -e "${YW}Enter the CT ID, or Press [ENTER] to automatically generate (${NEXTID}) "
+ read CT_ID
+ if [ -z $CT_ID ]; then CT_ID=$NEXTID; fi;
+ echo -en "${DGN}Set CT ID To ${BL}$CT_ID${CL}"
+echo -e " ${CM}${CL} \r"
+sleep 1
+clear
+header_info
+ echo -e "${RD}Using Advanced Settings${CL}"
+ echo -e "${DGN}Using CT Type ${BGN}$CT_TYPE1${CL}"
+ echo -e "${DGN}Using CT Password ${BGN}$PW1${CL}"
+ echo -e "${DGN}Using CT ID ${BGN}$CT_ID${CL}"
+ echo -e "${YW}Enter CT Name (no-spaces), or Press [ENTER] for Default: $NSAPP "
+ read CT_NAME
+ if [ -z $CT_NAME ]; then
+ HN=$NSAPP
+ else
+ HN=$(echo ${CT_NAME,,} | tr -d ' ')
+ fi
+ echo -en "${DGN}Set CT Name To ${BL}$HN${CL}"
+echo -e " ${CM}${CL} \r"
+sleep 1
+clear
+header_info
+ echo -e "${RD}Using Advanced Settings${CL}"
+ echo -e "${DGN}Using CT Type ${BGN}$CT_TYPE1${CL}"
+ echo -e "${DGN}Using CT Password ${BGN}$PW1${CL}"
+ echo -e "${DGN}Using CT ID ${BGN}$CT_ID${CL}"
+ echo -e "${DGN}Using CT Name ${BGN}$HN${CL}"
+ echo -e "${YW}Enter a Disk Size, or Press [ENTER] for Default: 2Gb "
+ read DISK_SIZE
+ if [ -z $DISK_SIZE ]; then DISK_SIZE="2"; fi;
+ if ! [[ $DISK_SIZE =~ $INTEGER ]] ; then echo "ERROR! DISK SIZE MUST HAVE INTEGER NUMBER!"; exit; fi;
+ echo -en "${DGN}Set Disk Size To ${BL}$DISK_SIZE${CL}"
+echo -e " ${CM}${CL} \r"
+sleep 1
+clear
+header_info
+ echo -e "${RD}Using Advanced Settings${CL}"
+ echo -e "${DGN}Using CT Type ${BGN}$CT_TYPE1${CL}"
+ echo -e "${DGN}Using CT Password ${BGN}$PW1${CL}"
+ echo -e "${DGN}Using CT ID ${BGN}$CT_ID${CL}"
+ echo -e "${DGN}Using CT Name ${BGN}$HN${CL}"
+ echo -e "${DGN}Using Disk Size ${BGN}$DISK_SIZE${CL}"
+ echo -e "${YW}Allocate CPU cores, or Press [ENTER] for Default: 1 "
+ read CORE_COUNT
+ if [ -z $CORE_COUNT ]; then CORE_COUNT="1"; fi;
+ echo -en "${DGN}Set Cores To ${BL}$CORE_COUNT${CL}"
+echo -e " ${CM}${CL} \r"
+sleep 1
+clear
+header_info
+ echo -e "${RD}Using Advanced Settings${CL}"
+ echo -e "${DGN}Using CT Type ${BGN}$CT_TYPE1${CL}"
+ echo -e "${DGN}Using CT Password ${BGN}$PW1${CL}"
+ echo -e "${DGN}Using CT ID ${BGN}$CT_ID${CL}"
+ echo -e "${DGN}Using CT Name ${BGN}$HN${CL}"
+ echo -e "${DGN}Using Disk Size ${BGN}$DISK_SIZE${CL}"
+ echo -e "${DGN}Using ${BGN}${CORE_COUNT}vCPU${CL}"
+ echo -e "${YW}Allocate RAM in MiB, or Press [ENTER] for Default: 512 "
+ read RAM_SIZE
+ if [ -z $RAM_SIZE ]; then RAM_SIZE="512"; fi;
+ echo -en "${DGN}Set RAM To ${BL}$RAM_SIZE${CL}"
+echo -e " ${CM}${CL} \n"
+sleep 1
+clear
+header_info
+ echo -e "${RD}Using Advanced Settings${CL}"
+ echo -e "${DGN}Using CT Type ${BGN}$CT_TYPE1${CL}"
+ echo -e "${DGN}Using CT Password ${BGN}$PW1${CL}"
+ echo -e "${DGN}Using CT ID ${BGN}$CT_ID${CL}"
+ echo -e "${DGN}Using CT Name ${BGN}$HN${CL}"
+ echo -e "${DGN}Using Disk Size ${BGN}$DISK_SIZE${CL}"
+ echo -e "${DGN}Using ${BGN}${CORE_COUNT}vCPU${CL}"
+ echo -e "${DGN}Using ${BGN}${RAM_SIZE}MiB${CL}${DGN} RAM${CL}"
+ echo -e "${YW}Enter a Static IP Address, or Press [ENTER] for Default: DHCP "
+ read NET
+ if [ -z $NET ]; then NET="dhcp"; fi;
+ echo -en "${DGN}Set Static IP Address To ${BL}$NET${CL}"
+echo -e " ${CM}${CL} \n"
+sleep 1
+clear
+header_info
+ echo -e "${RD}Using Advanced Settings${CL}"
+ echo -e "${DGN}Using CT Type ${BGN}$CT_TYPE1${CL}"
+ echo -e "${DGN}Using CT Password ${BGN}$PW1${CL}"
+ echo -e "${DGN}Using CT ID ${BGN}$CT_ID${CL}"
+ echo -e "${DGN}Using CT Name ${BGN}$HN${CL}"
+ echo -e "${DGN}Using Disk Size ${BGN}$DISK_SIZE${CL}"
+ echo -e "${DGN}Using ${BGN}${CORE_COUNT}vCPU${CL}"
+ echo -e "${DGN}Using ${BGN}${RAM_SIZE}MiB${CL}${DGN} RAM${CL}"
+ echo -e "${DGN}Using Static IP Address ${BGN}$NET${CL}"
+ echo -e "${YW}Enter a Gateway IP, or Press [ENTER] for Default: NONE "
+ read GATE1
+ if [ -z $GATE1 ]; then GATE1="NONE" GATE=" ";
+ echo -en "${DGN}Set Gateway IP To ${BL}$GATE1${CL}"
+ else
+ GATE=",gw=$GATE1"
+ echo -en "${DGN}Set Gateway IP To ${BL}$GATE1${CL}"
+ fi;
+echo -e " ${CM}${CL} \n"
+sleep 1
+clear
+header_info
+
+ echo -e "${RD}Using Advanced Settings${CL}"
+ echo -e "${DGN}Using CT Type ${BGN}$CT_TYPE1${CL}"
+ echo -e "${DGN}Using CT Password ${BGN}$PW1${CL}"
+ echo -e "${DGN}Using CT ID ${BGN}$CT_ID${CL}"
+ echo -e "${DGN}Using CT Name ${BGN}$HN${CL}"
+ echo -e "${DGN}Using Disk Size ${BGN}$DISK_SIZE${CL}"
+ echo -e "${DGN}Using ${BGN}${CORE_COUNT}vCPU${CL}"
+ echo -e "${DGN}Using ${BGN}${RAM_SIZE}MiB${CL}${DGN} RAM${CL}"
+ echo -e "${DGN}Using Static IP Address ${BGN}$NET${CL}"
+ echo -e "${DGN}Using Gateway IP Address ${BGN}$GATE1${CL}"
+ echo -e "${YW}Enter a VLAN Tag, or Press [ENTER] for Default: NONE "
+ read VLAN1
+ if [ -z $VLAN1 ]; then VLAN1="NONE" VLAN=" ";
+ echo -en "${DGN}Set VLAN Tag To ${BL}$VLAN1${CL}"
+ else
+ VLAN=",tag=$VLAN1"
+ echo -en "${DGN}Set VLAN Tag To ${BL}$VLAN1${CL}"
+ fi;
+echo -e " ${CM}${CL} \n"
+sleep 1
+clear
+header_info
+ echo -e "${RD}Using Advanced Settings${CL}"
+ echo -e "${DGN}Using CT Type ${BGN}$CT_TYPE1${CL}"
+ echo -e "${DGN}Using CT Password ${BGN}$PW1${CL}"
+ echo -e "${DGN}Using CT ID ${BGN}$CT_ID${CL}"
+ echo -e "${DGN}Using CT Name ${BGN}$HN${CL}"
+ echo -e "${DGN}Using Disk Size ${BGN}$DISK_SIZE${CL}"
+ echo -e "${DGN}Using ${BGN}${CORE_COUNT}vCPU${CL}"
+ echo -e "${DGN}Using ${BGN}${RAM_SIZE}MiB${CL}${DGN} RAM${CL}"
+ echo -e "${DGN}Using Static IP Address ${BGN}$NET${CL}"
+ echo -e "${DGN}Using Gateway IP Address ${BGN}$GATE1${CL}"
+ echo -e "${DGN}Using VLAN Tag ${BGN}$VLAN1${CL}"
+
+read -p "Are these settings correct(y/n)? " -n 1 -r
+echo
+if [[ ! $REPLY =~ ^[Yy]$ ]]
+then
+ advanced_settings
+fi
+}
+
+function start_script() {
+ echo -e "${YW}Type Advanced, or Press [ENTER] for Default Settings "
+ read SETTINGS
+ if [ -z $SETTINGS ]; then default_settings;
+ else
+ advanced_settings
+ fi;
+}
+
+start_script
+
+if [ "$CT_TYPE" == "1" ]; then
+ FEATURES="nesting=1,keyctl=1"
+ else
+ FEATURES="nesting=1"
+ fi
+
+TEMP_DIR=$(mktemp -d)
+pushd $TEMP_DIR >/dev/null
+
+export CTID=$CT_ID
+export PCT_OSTYPE=debian
+export PCT_OSVERSION=11
+export PCT_DISK_SIZE=$DISK_SIZE
+export PCT_OPTIONS="
+ -features $FEATURES
+ -hostname $HN
+ -net0 name=eth0,bridge=vmbr0,ip=$NET$GATE$VLAN
+ -onboot 1
+ -cores $CORE_COUNT
+ -memory $RAM_SIZE
+ -unprivileged $CT_TYPE
+ $PW
+"
+bash -c "$(wget -qLO - https://raw.githubusercontent.com/tteck/Proxmox/main/ct/create_lxc.sh)" || exit
+
+msg_info "Starting LXC Container"
+pct start $CTID
+msg_ok "Started LXC Container"
+
+lxc-attach -n $CTID -- bash -c "$(wget -qLO - https://raw.githubusercontent.com/tteck/Proxmox/main/setup/mqtt-install.sh)" || exit
+
+IP=$(pct exec $CTID ip a s dev eth0 | sed -n '/inet / s/\// /p' | awk '{print $2}')
+
+msg_ok "Completed Successfully!\n"
diff --git a/ct/node-red_container.sh b/ct/node-red-v1.sh
similarity index 100%
rename from ct/node-red_container.sh
rename to ct/node-red-v1.sh
diff --git a/ct/node-red.sh b/ct/node-red-v2.sh
similarity index 100%
rename from ct/node-red.sh
rename to ct/node-red-v2.sh
diff --git a/ct/node-red-v3.sh b/ct/node-red-v3.sh
new file mode 100644
index 00000000..1f0d38bb
--- /dev/null
+++ b/ct/node-red-v3.sh
@@ -0,0 +1,315 @@
+#!/usr/bin/env bash -ex
+set -euo pipefail
+shopt -s inherit_errexit nullglob
+
+NEXTID=$(pvesh get /cluster/nextid)
+INTEGER='^[0-9]+$'
+YW=`echo "\033[33m"`
+BL=`echo "\033[36m"`
+RD=`echo "\033[01;31m"`
+BGN=`echo "\033[4;92m"`
+GN=`echo "\033[1;92m"`
+DGN=`echo "\033[32m"`
+CL=`echo "\033[m"`
+BFR="\\r\\033[K"
+HOLD="-"
+CM="${GN}✓${CL}"
+APP="Node Red"
+NSAPP=$(echo ${APP,,} | tr -d ' ')
+while true; do
+ read -p "This will create a New ${APP} LXC. Proceed(y/n)?" yn
+ case $yn in
+ [Yy]* ) break;;
+ [Nn]* ) exit;;
+ * ) echo "Please answer yes or no.";;
+ esac
+done
+clear
+function header_info {
+echo -e "${RD}
+ _ _ _ _____ _
+ | \ | | | | | __ \ | |
+ | \| | ___ __| | ___ ______| |__) |___ __| |
+ | |/ _ \ / _ |/ _ \__v3__| _ // _ \/ _ |
+ | |\ | (_) | (_| | __/ | | \ \ __/ (_| |
+ |_| \_|\___/ \__,_|\___| |_| \_\___|\__,_|
+${CL}"
+}
+
+header_info
+
+function msg_info() {
+ local msg="$1"
+ echo -ne " ${HOLD} ${YW}${msg}..."
+}
+
+function msg_ok() {
+ local msg="$1"
+ echo -e "${BFR} ${CM} ${GN}${msg}${CL}"
+}
+
+function PVE_CHECK() {
+ PVE=$(pveversion | grep "pve-manager/7" | wc -l)
+
+ if [[ $PVE != 1 ]]; then
+ echo -e "${RD}This script requires Proxmox Virtual Environment 7.0 or greater${CL}"
+ echo -e "Exiting..."
+ sleep 2
+ exit
+ fi
+}
+
+function default_settings() {
+ clear
+ header_info
+ echo -e "${BL}Using Default Settings${CL}"
+ echo -e "${DGN}Using CT Type ${BGN}Unprivileged${CL} ${RD}NO DEVICE PASSTHROUGH${CL}"
+ CT_TYPE="1"
+ echo -e "${DGN}Using CT Password ${BGN}Automatic Login${CL}"
+ PW=" "
+ echo -e "${DGN}Using CT ID ${BGN}$NEXTID${CL}"
+ CT_ID=$NEXTID
+ echo -e "${DGN}Using CT Name ${BGN}$NSAPP${CL}"
+ HN=$NSAPP
+ echo -e "${DGN}Using Disk Size ${BGN}4GB${CL}"
+ DISK_SIZE="4"
+ echo -e "${DGN}Using ${BGN}1vCPU${CL}"
+ CORE_COUNT="1"
+ echo -e "${DGN}Using ${BGN}1024MiB${CL}${DGN} RAM${CL}"
+ RAM_SIZE="1024"
+ echo -e "${DGN}Using Static IP Address ${BGN}DHCP${CL}"
+ NET=dhcp
+ echo -e "${DGN}Using Gateway Address ${BGN}NONE${CL}"
+ GATE=" "
+ echo -e "${DGN}Using VLAN Tag ${BGN}NONE${CL}"
+ VLAN=" "
+}
+
+function advanced_settings() {
+ clear
+ header_info
+ echo -e "${RD}Using Advanced Settings${CL}"
+ echo -e "${YW}Type Privileged, or Press [ENTER] for Default: Unprivileged (${RD}NO DEVICE PASSTHROUGH${CL}${YW})"
+ read CT_TYPE1
+ if [ -z $CT_TYPE1 ]; then CT_TYPE1="Unprivileged" CT_TYPE="1";
+ echo -en "${DGN}Set CT Type ${BL}$CT_TYPE1${CL}"
+ else
+ CT_TYPE1="Privileged"
+ CT_TYPE="0"
+ echo -en "${DGN}Set CT Type ${BL}Privileged${CL}"
+ fi;
+echo -e " ${CM}${CL} \r"
+sleep 1
+clear
+header_info
+ echo -e "${RD}Using Advanced Settings${CL}"
+ echo -e "${DGN}Using CT Type ${BGN}$CT_TYPE1${CL}"
+ echo -e "${YW}Set Password, or Press [ENTER] for Default: Automatic Login "
+ read PW1
+ if [ -z $PW1 ]; then PW1="Automatic Login" PW=" ";
+ echo -en "${DGN}Set CT ${BL}$PW1${CL}"
+ else
+ PW="-password $PW1"
+ echo -en "${DGN}Set CT Password ${BL}$PW1${CL}"
+ fi;
+echo -e " ${CM}${CL} \r"
+sleep 1
+clear
+header_info
+ echo -e "${RD}Using Advanced Settings${CL}"
+ echo -e "${DGN}Using CT Type ${BGN}$CT_TYPE1${CL}"
+ echo -e "${DGN}Using CT Password ${BGN}$PW1${CL}"
+ echo -e "${YW}Enter the CT ID, or Press [ENTER] to automatically generate (${NEXTID}) "
+ read CT_ID
+ if [ -z $CT_ID ]; then CT_ID=$NEXTID; fi;
+ echo -en "${DGN}Set CT ID To ${BL}$CT_ID${CL}"
+echo -e " ${CM}${CL} \r"
+sleep 1
+clear
+header_info
+ echo -e "${RD}Using Advanced Settings${CL}"
+ echo -e "${DGN}Using CT Type ${BGN}$CT_TYPE1${CL}"
+ echo -e "${DGN}Using CT Password ${BGN}$PW1${CL}"
+ echo -e "${DGN}Using CT ID ${BGN}$CT_ID${CL}"
+ echo -e "${YW}Enter CT Name (no-spaces), or Press [ENTER] for Default: $NSAPP "
+ read CT_NAME
+ if [ -z $CT_NAME ]; then
+ HN=$NSAPP
+ else
+ HN=$(echo ${CT_NAME,,} | tr -d ' ')
+ fi
+ echo -en "${DGN}Set CT Name To ${BL}$HN${CL}"
+echo -e " ${CM}${CL} \r"
+sleep 1
+clear
+header_info
+ echo -e "${RD}Using Advanced Settings${CL}"
+ echo -e "${DGN}Using CT Type ${BGN}$CT_TYPE1${CL}"
+ echo -e "${DGN}Using CT Password ${BGN}$PW1${CL}"
+ echo -e "${DGN}Using CT ID ${BGN}$CT_ID${CL}"
+ echo -e "${DGN}Using CT Name ${BGN}$HN${CL}"
+ echo -e "${YW}Enter a Disk Size, or Press [ENTER] for Default: 4Gb "
+ read DISK_SIZE
+ if [ -z $DISK_SIZE ]; then DISK_SIZE="4"; fi;
+ if ! [[ $DISK_SIZE =~ $INTEGER ]] ; then echo "ERROR! DISK SIZE MUST HAVE INTEGER NUMBER!"; exit; fi;
+ echo -en "${DGN}Set Disk Size To ${BL}$DISK_SIZE${CL}"
+echo -e " ${CM}${CL} \r"
+sleep 1
+clear
+header_info
+ echo -e "${RD}Using Advanced Settings${CL}"
+ echo -e "${DGN}Using CT Type ${BGN}$CT_TYPE1${CL}"
+ echo -e "${DGN}Using CT Password ${BGN}$PW1${CL}"
+ echo -e "${DGN}Using CT ID ${BGN}$CT_ID${CL}"
+ echo -e "${DGN}Using CT Name ${BGN}$HN${CL}"
+ echo -e "${DGN}Using Disk Size ${BGN}$DISK_SIZE${CL}"
+ echo -e "${YW}Allocate CPU cores, or Press [ENTER] for Default: 1 "
+ read CORE_COUNT
+ if [ -z $CORE_COUNT ]; then CORE_COUNT="1"; fi;
+ echo -en "${DGN}Set Cores To ${BL}$CORE_COUNT${CL}"
+echo -e " ${CM}${CL} \r"
+sleep 1
+clear
+header_info
+ echo -e "${RD}Using Advanced Settings${CL}"
+ echo -e "${DGN}Using CT Type ${BGN}$CT_TYPE1${CL}"
+ echo -e "${DGN}Using CT Password ${BGN}$PW1${CL}"
+ echo -e "${DGN}Using CT ID ${BGN}$CT_ID${CL}"
+ echo -e "${DGN}Using CT Name ${BGN}$HN${CL}"
+ echo -e "${DGN}Using Disk Size ${BGN}$DISK_SIZE${CL}"
+ echo -e "${DGN}Using ${BGN}${CORE_COUNT}vCPU${CL}"
+ echo -e "${YW}Allocate RAM in MiB, or Press [ENTER] for Default: 1024 "
+ read RAM_SIZE
+ if [ -z $RAM_SIZE ]; then RAM_SIZE="1024"; fi;
+ echo -en "${DGN}Set RAM To ${BL}$RAM_SIZE${CL}"
+echo -e " ${CM}${CL} \n"
+sleep 1
+clear
+header_info
+ echo -e "${RD}Using Advanced Settings${CL}"
+ echo -e "${DGN}Using CT Type ${BGN}$CT_TYPE1${CL}"
+ echo -e "${DGN}Using CT Password ${BGN}$PW1${CL}"
+ echo -e "${DGN}Using CT ID ${BGN}$CT_ID${CL}"
+ echo -e "${DGN}Using CT Name ${BGN}$HN${CL}"
+ echo -e "${DGN}Using Disk Size ${BGN}$DISK_SIZE${CL}"
+ echo -e "${DGN}Using ${BGN}${CORE_COUNT}vCPU${CL}"
+ echo -e "${DGN}Using ${BGN}${RAM_SIZE}MiB${CL}${DGN} RAM${CL}"
+ echo -e "${YW}Enter a Static IP Address, or Press [ENTER] for Default: DHCP "
+ read NET
+ if [ -z $NET ]; then NET="dhcp"; fi;
+ echo -en "${DGN}Set Static IP Address To ${BL}$NET${CL}"
+echo -e " ${CM}${CL} \n"
+sleep 1
+clear
+header_info
+ echo -e "${RD}Using Advanced Settings${CL}"
+ echo -e "${DGN}Using CT Type ${BGN}$CT_TYPE1${CL}"
+ echo -e "${DGN}Using CT Password ${BGN}$PW1${CL}"
+ echo -e "${DGN}Using CT ID ${BGN}$CT_ID${CL}"
+ echo -e "${DGN}Using CT Name ${BGN}$HN${CL}"
+ echo -e "${DGN}Using Disk Size ${BGN}$DISK_SIZE${CL}"
+ echo -e "${DGN}Using ${BGN}${CORE_COUNT}vCPU${CL}"
+ echo -e "${DGN}Using ${BGN}${RAM_SIZE}MiB${CL}${DGN} RAM${CL}"
+ echo -e "${DGN}Using Static IP Address ${BGN}$NET${CL}"
+ echo -e "${YW}Enter a Gateway IP, or Press [ENTER] for Default: NONE "
+ read GATE1
+ if [ -z $GATE1 ]; then GATE1="NONE" GATE=" ";
+ echo -en "${DGN}Set Gateway IP To ${BL}$GATE1${CL}"
+ else
+ GATE=",gw=$GATE1"
+ echo -en "${DGN}Set Gateway IP To ${BL}$GATE1${CL}"
+ fi;
+echo -e " ${CM}${CL} \n"
+sleep 1
+clear
+header_info
+
+ echo -e "${RD}Using Advanced Settings${CL}"
+ echo -e "${DGN}Using CT Type ${BGN}$CT_TYPE1${CL}"
+ echo -e "${DGN}Using CT Password ${BGN}$PW1${CL}"
+ echo -e "${DGN}Using CT ID ${BGN}$CT_ID${CL}"
+ echo -e "${DGN}Using CT Name ${BGN}$HN${CL}"
+ echo -e "${DGN}Using Disk Size ${BGN}$DISK_SIZE${CL}"
+ echo -e "${DGN}Using ${BGN}${CORE_COUNT}vCPU${CL}"
+ echo -e "${DGN}Using ${BGN}${RAM_SIZE}MiB${CL}${DGN} RAM${CL}"
+ echo -e "${DGN}Using Static IP Address ${BGN}$NET${CL}"
+ echo -e "${DGN}Using Gateway IP Address ${BGN}$GATE1${CL}"
+ echo -e "${YW}Enter a VLAN Tag, or Press [ENTER] for Default: NONE "
+ read VLAN1
+ if [ -z $VLAN1 ]; then VLAN1="NONE" VLAN=" ";
+ echo -en "${DGN}Set VLAN Tag To ${BL}$VLAN1${CL}"
+ else
+ VLAN=",tag=$VLAN1"
+ echo -en "${DGN}Set VLAN Tag To ${BL}$VLAN1${CL}"
+ fi;
+echo -e " ${CM}${CL} \n"
+sleep 1
+clear
+header_info
+ echo -e "${RD}Using Advanced Settings${CL}"
+ echo -e "${DGN}Using CT Type ${BGN}$CT_TYPE1${CL}"
+ echo -e "${DGN}Using CT Password ${BGN}$PW1${CL}"
+ echo -e "${DGN}Using CT ID ${BGN}$CT_ID${CL}"
+ echo -e "${DGN}Using CT Name ${BGN}$HN${CL}"
+ echo -e "${DGN}Using Disk Size ${BGN}$DISK_SIZE${CL}"
+ echo -e "${DGN}Using ${BGN}${CORE_COUNT}vCPU${CL}"
+ echo -e "${DGN}Using ${BGN}${RAM_SIZE}MiB${CL}${DGN} RAM${CL}"
+ echo -e "${DGN}Using Static IP Address ${BGN}$NET${CL}"
+ echo -e "${DGN}Using Gateway IP Address ${BGN}$GATE1${CL}"
+ echo -e "${DGN}Using VLAN Tag ${BGN}$VLAN1${CL}"
+
+read -p "Are these settings correct(y/n)? " -n 1 -r
+echo
+if [[ ! $REPLY =~ ^[Yy]$ ]]
+then
+ advanced_settings
+fi
+}
+
+function start_script() {
+ echo -e "${YW}Type Advanced, or Press [ENTER] for Default Settings "
+ read SETTINGS
+ if [ -z $SETTINGS ]; then default_settings;
+ else
+ advanced_settings
+ fi;
+}
+
+start_script
+
+if [ "$CT_TYPE" == "1" ]; then
+ FEATURES="nesting=1,keyctl=1"
+ else
+ FEATURES="nesting=1"
+ fi
+
+TEMP_DIR=$(mktemp -d)
+pushd $TEMP_DIR >/dev/null
+
+export CTID=$CT_ID
+export PCT_OSTYPE=debian
+export PCT_OSVERSION=11
+export PCT_DISK_SIZE=$DISK_SIZE
+export PCT_OPTIONS="
+ -features $FEATURES
+ -hostname $HN
+ -net0 name=eth0,bridge=vmbr0,ip=$NET$GATE$VLAN
+ -onboot 1
+ -cores $CORE_COUNT
+ -memory $RAM_SIZE
+ -unprivileged $CT_TYPE
+ $PW
+"
+bash -c "$(wget -qLO - https://raw.githubusercontent.com/tteck/Proxmox/main/ct/create_lxc.sh)" || exit
+
+msg_info "Starting LXC Container"
+pct start $CTID
+msg_ok "Started LXC Container"
+
+lxc-attach -n $CTID -- bash -c "$(wget -qLO - https://raw.githubusercontent.com/tteck/Proxmox/main/setup/node-red-install.sh)" || exit
+
+IP=$(pct exec $CTID ip a s dev eth0 | sed -n '/inet / s/\// /p' | awk '{print $2}')
+
+msg_ok "Completed Successfully!\n"
+echo -e "${APP} should be reachable by going to the following URL.
+ ${BL}http://${IP}:1880${CL} \n"
diff --git a/setup/mariadb-install.sh b/setup/mariadb-install.sh
index e4cb0062..ced8fe7f 100644
--- a/setup/mariadb-install.sh
+++ b/setup/mariadb-install.sh
@@ -1,38 +1,30 @@
-#!/usr/bin/env bash
-
-set -o errexit
-set -o errtrace
-set -o nounset
-set -o pipefail
-shopt -s expand_aliases
-alias die='EXIT=$? LINE=$LINENO error_exit'
-trap die ERR
-trap 'die "Script interrupted."' INT
-
-function error_exit() {
- trap - ERR
- local DEFAULT='Unknown failure occured.'
- local REASON="\e[97m${1:-$DEFAULT}\e[39m"
- local FLAG="\e[91m[ERROR:LXC] \e[93m$EXIT@$LINE"
- msg "$FLAG $REASON"
- exit $EXIT
-}
-function msg() {
- local TEXT="$1"
- echo -e "$TEXT"
-}
-
+#!/usr/bin/env bash -ex
+set -euo pipefail
+shopt -s inherit_errexit nullglob
+YW=`echo "\033[33m"`
RD=`echo "\033[01;31m"`
BL=`echo "\033[36m"`
GN=`echo "\033[1;92m"`
CL=`echo "\033[m"`
-CM="${GN}✓${CL}"
-CROSS="${RD}✗${CL}"
RETRY_NUM=10
RETRY_EVERY=3
NUM=$RETRY_NUM
+CM="${GN}✓${CL}"
+CROSS="${RD}✗${CL}"
+BFR="\\r\\033[K"
+HOLD="-"
-echo -en "${GN} Setting up Container OS... "
+function msg_info() {
+ local msg="$1"
+ echo -ne " ${HOLD} ${YW}${msg}..."
+}
+
+function msg_ok() {
+ local msg="$1"
+ echo -e "${BFR} ${CM} ${GN}${msg}${CL}"
+}
+
+msg_info "Setting up Container OS "
sed -i "/$LANG/ s/\(^# \)//" /etc/locale.gen
locale-gen >/dev/null
while [ "$(hostname -I)" = "" ]; do
@@ -45,35 +37,34 @@ while [ "$(hostname -I)" = "" ]; do
exit 1
fi
done
-echo -e "${CM}${CL} \r"
-echo -en "${GN} Network Connected: ${BL}$(hostname -I)${CL} "
-echo -e "${CM}${CL} \r"
+msg_ok "Set up Container OS"
+msg_ok "Network Connected: ${BL}$(hostname -I)"
-echo -en "${GN} Updating Container OS... "
+msg_info "Updating Container OS"
apt update &>/dev/null
apt-get -qqy upgrade &>/dev/null
-echo -e "${CM}${CL} \r"
+msg_ok "Updated Container OS"
-echo -en "${GN} Installing Dependencies... "
+msg_info "Installing Dependencies"
apt-get install -y curl &>/dev/null
apt-get install -y sudo &>/dev/null
-echo -e "${CM}${CL} \r"
+msg_ok "Installed Dependencies"
-echo -en "${GN} Installing MariaDB... "
+msg_info "Installing MariaDB"
curl -LsS https://r.mariadb.com/downloads/mariadb_repo_setup | sudo bash &>/dev/null
apt-get update >/dev/null
apt-get install -y mariadb-server &>/dev/null
-echo -e "${CM}${CL} \r"
+msg_ok "Installed MariaDB"
-echo -en "${GN} Installing Adminer... "
+msg_info "Installing Adminer"
sudo apt install adminer -y &>/dev/null
sudo a2enconf adminer &>/dev/null
sudo systemctl reload apache2 &>/dev/null
-echo -e "${CM}${CL} \r"
+msg_ok "Installed Adminer"
PASS=$(grep -w "root" /etc/shadow | cut -b6);
if [[ $PASS != $ ]]; then
-echo -en "${GN} Customizing Container... "
+msg_info "Customizing Container"
rm /etc/motd
rm /etc/update-motd.d/10-uname
touch ~/.hushlogin
@@ -86,13 +77,13 @@ ExecStart=-/sbin/agetty --autologin root --noclear --keep-baud tty%I 115200,3840
EOF
systemctl daemon-reload
systemctl restart $(basename $(dirname $GETTY_OVERRIDE) | sed 's/\.d//')
-echo -e "${CM}${CL} \r"
+msg_ok "Customized Container"
fi
-echo -en "${GN} Cleanup... "
+msg_info "Cleaning up"
apt-get autoremove >/dev/null
apt-get autoclean >/dev/null
rm -rf /var/{cache,log}/* /var/lib/apt/lists/*
mkdir /var/log/apache2
chmod 750 /var/log/apache2
-echo -e "${CM}${CL} \n"
+msg_ok "Cleaned"
diff --git a/setup/mqtt-install.sh b/setup/mqtt-install.sh
index d96fac5a..1a54f90d 100644
--- a/setup/mqtt-install.sh
+++ b/setup/mqtt-install.sh
@@ -1,38 +1,30 @@
-#!/usr/bin/env bash
-
-set -o errexit
-set -o errtrace
-set -o nounset
-set -o pipefail
-shopt -s expand_aliases
-alias die='EXIT=$? LINE=$LINENO error_exit'
-trap die ERR
-trap 'die "Script interrupted."' INT
-
-function error_exit() {
- trap - ERR
- local DEFAULT='Unknown failure occured.'
- local REASON="\e[97m${1:-$DEFAULT}\e[39m"
- local FLAG="\e[91m[ERROR:LXC] \e[93m$EXIT@$LINE"
- msg "$FLAG $REASON"
- exit $EXIT
-}
-function msg() {
- local TEXT="$1"
- echo -e "$TEXT"
-}
-
+#!/usr/bin/env bash -ex
+set -euo pipefail
+shopt -s inherit_errexit nullglob
+YW=`echo "\033[33m"`
RD=`echo "\033[01;31m"`
BL=`echo "\033[36m"`
GN=`echo "\033[1;92m"`
CL=`echo "\033[m"`
-CM="${GN}✓${CL}"
-CROSS="${RD}✗${CL}"
RETRY_NUM=10
RETRY_EVERY=3
NUM=$RETRY_NUM
+CM="${GN}✓${CL}"
+CROSS="${RD}✗${CL}"
+BFR="\\r\\033[K"
+HOLD="-"
-echo -en "${GN} Setting up Container OS... "
+function msg_info() {
+ local msg="$1"
+ echo -ne " ${HOLD} ${YW}${msg}..."
+}
+
+function msg_ok() {
+ local msg="$1"
+ echo -e "${BFR} ${CM} ${GN}${msg}${CL}"
+}
+
+msg_info "Setting up Container OS "
sed -i "/$LANG/ s/\(^# \)//" /etc/locale.gen
locale-gen >/dev/null
while [ "$(hostname -I)" = "" ]; do
@@ -45,22 +37,21 @@ while [ "$(hostname -I)" = "" ]; do
exit 1
fi
done
-echo -e "${CM}${CL} \r"
-echo -en "${GN} Network Connected: ${BL}$(hostname -I)${CL} "
-echo -e "${CM}${CL} \r"
+msg_ok "Set up Container OS"
+msg_ok "Network Connected: ${BL}$(hostname -I)"
-echo -en "${GN} Updating Container OS... "
+msg_info "Updating Container OS"
apt update &>/dev/null
apt-get -qqy upgrade &>/dev/null
-echo -e "${CM}${CL} \r"
+msg_ok "Updated Container OS"
-echo -en "${GN} Installing Dependencies... "
+msg_info "Installing Dependencies"
apt-get install -y curl &>/dev/null
apt-get install -y sudo &>/dev/null
apt-get install -y gnupg &>/dev/null
-echo -e "${CM}${CL} \r"
+msg_ok "Installed Dependencies"
-echo -en "${GN} Installing Mosquitto MQTT Broker... "
+msg_info "Installing Mosquitto MQTT Broker"
wget http://repo.mosquitto.org/debian/mosquitto-repo.gpg.key &>/dev/null
apt-key add mosquitto-repo.gpg.key &>/dev/null
cd /etc/apt/sources.list.d/
@@ -68,11 +59,11 @@ wget http://repo.mosquitto.org/debian/mosquitto-bullseye.list &>/dev/null
apt-get update >/dev/null
apt-get -y install mosquitto &>/dev/null
apt-get -y install mosquitto-clients &>/dev/null
-echo -e "${CM}${CL} \r"
+msg_ok "Installed Mosquitto MQTT Broker"
PASS=$(grep -w "root" /etc/shadow | cut -b6);
if [[ $PASS != $ ]]; then
-echo -en "${GN} Customizing Container... "
+msg_info "Customizing Container"
rm /etc/motd
rm /etc/update-motd.d/10-uname
touch ~/.hushlogin
@@ -85,11 +76,11 @@ ExecStart=-/sbin/agetty --autologin root --noclear --keep-baud tty%I 115200,3840
EOF
systemctl daemon-reload
systemctl restart $(basename $(dirname $GETTY_OVERRIDE) | sed 's/\.d//')
-echo -e "${CM}${CL} \r"
+msg_ok "Customized Container"
fi
-
-echo -en "${GN} Cleanup... "
+
+msg_info "Cleaning up"
apt-get autoremove >/dev/null
apt-get autoclean >/dev/null
rm -rf /var/{cache,log}/* /var/lib/apt/lists/*
-echo -e "${CM}${CL} \n"
+msg_ok "Cleaned"
diff --git a/setup/node-red-install.sh b/setup/node-red-install.sh
index 7bf0de50..1a891678 100644
--- a/setup/node-red-install.sh
+++ b/setup/node-red-install.sh
@@ -1,38 +1,30 @@
-#!/usr/bin/env bash
-
-set -o errexit
-set -o errtrace
-set -o nounset
-set -o pipefail
-shopt -s expand_aliases
-alias die='EXIT=$? LINE=$LINENO error_exit'
-trap die ERR
-trap 'die "Script interrupted."' INT
-
-function error_exit() {
- trap - ERR
- local DEFAULT='Unknown failure occured.'
- local REASON="\e[97m${1:-$DEFAULT}\e[39m"
- local FLAG="\e[91m[ERROR:LXC] \e[93m$EXIT@$LINE"
- msg "$FLAG $REASON"
- exit $EXIT
-}
-function msg() {
- local TEXT="$1"
- echo -e "$TEXT"
-}
-
+#!/usr/bin/env bash -ex
+set -euo pipefail
+shopt -s inherit_errexit nullglob
+YW=`echo "\033[33m"`
RD=`echo "\033[01;31m"`
BL=`echo "\033[36m"`
GN=`echo "\033[1;92m"`
CL=`echo "\033[m"`
-CM="${GN}✓${CL}"
-CROSS="${RD}✗${CL}"
RETRY_NUM=10
RETRY_EVERY=3
NUM=$RETRY_NUM
+CM="${GN}✓${CL}"
+CROSS="${RD}✗${CL}"
+BFR="\\r\\033[K"
+HOLD="-"
-echo -en "${GN} Setting up Container OS... "
+function msg_info() {
+ local msg="$1"
+ echo -ne " ${HOLD} ${YW}${msg}..."
+}
+
+function msg_ok() {
+ local msg="$1"
+ echo -e "${BFR} ${CM} ${GN}${msg}${CL}"
+}
+
+msg_info "Setting up Container OS "
sed -i "/$LANG/ s/\(^# \)//" /etc/locale.gen
locale-gen >/dev/null
while [ "$(hostname -I)" = "" ]; do
@@ -45,29 +37,28 @@ while [ "$(hostname -I)" = "" ]; do
exit 1
fi
done
-echo -e "${CM}${CL} \r"
-echo -en "${GN} Network Connected: ${BL}$(hostname -I)${CL} "
-echo -e "${CM}${CL} \r"
+msg_ok "Set up Container OS"
+msg_ok "Network Connected: ${BL}$(hostname -I)"
-echo -en "${GN} Updating Container OS... "
+msg_info "Updating Container OS"
apt update &>/dev/null
apt-get -qqy upgrade &>/dev/null
-echo -e "${CM}${CL} \r"
+msg_ok "Updated Container OS"
-echo -en "${GN} Installing Dependencies... "
+msg_info "Installing Dependencies"
apt-get install -y curl &>/dev/null
apt-get install -y sudo &>/dev/null
-echo -e "${CM}${CL} \r"
+msg_ok "Installed Dependencies"
-echo -en "${GN} Installing Node-Red... "
+msg_info "Installing Node-Red"
bash <(curl -sL https://raw.githubusercontent.com/node-red/linux-installers/master/deb/update-nodejs-and-nodered) --confirm-root --confirm-install --skip-pi &>/dev/nul
sudo systemctl enable nodered.service &>/dev/null
sudo systemctl start nodered.service &>/dev/null
-echo -e "${CM}${CL} \r"
+msg_ok "Installed Node-Red"
PASS=$(grep -w "root" /etc/shadow | cut -b6);
if [[ $PASS != $ ]]; then
-echo -en "${GN} Customizing Container... "
+msg_info "Customizing Container"
rm /etc/motd
rm /etc/update-motd.d/10-uname
touch ~/.hushlogin
@@ -80,11 +71,11 @@ ExecStart=-/sbin/agetty --autologin root --noclear --keep-baud tty%I 115200,3840
EOF
systemctl daemon-reload
systemctl restart $(basename $(dirname $GETTY_OVERRIDE) | sed 's/\.d//')
-echo -e "${CM}${CL} \r"
+msg_ok "Customized Container"
fi
-
-echo -en "${GN} Cleanup... "
+
+msg_info "Cleaning up"
apt-get autoremove >/dev/null
apt-get autoclean >/dev/null
rm -rf /var/{cache,log}/* /var/lib/apt/lists/*
-echo -e "${CM}${CL} \n"
+msg_ok "Cleaned"